#include  "CVector.h"
#include  "CMatrix.h"
#include  "CUpperTriangularMatrix.h"
#include  "CLowerTriangularMatrix.h"

// insert exception class headers here
#include

#include <iostream>

using namespace std;

int main(int argc,char *argv[])
{
	try {
	   CLowerTriangularMatrix A(5, 7, 2);
	} 
	catch (SquareMatrixExpectedException& e) {
		cout << e.what() ;
	}

	try {
	  CMatrix B(3,5,1.) ;
          CMatrix C(2,4,2.) ;
          B+C;
          B-C;	  
	} 
	catch (SizeMismatchException& e) {
		cout << e.what() ;
	}

	try {
	  CMatrix D(2,3,1.) ;
          CMatrix E(5,3,2.) ;
          D*E;	  
	} 
	catch (SizeMismatchException& e) {
		cout << e.what() ;
	}

	try {
	  CMatrix F(3,5,1.) ;
	  cout << F(-2,2) ;
	} 
	catch (NegativeIndexException& e) {
		cout << e.what() ;
	}


	try {
	  CMatrix G(3,5,1.) ;
	  cout << G(1,6) ;
	} 
	catch (OutOfBoundsException& e) {
		cout << e.what() ;
	}

   
	try {
	  CMatrix H(3,5,1.) ;
	  H/0.;
	} 
	catch (DivideByZeroException& e) {
		cout << e.what() ;
	}
	
        try{
          CMatrix J(2,2,1.);
          CMatrix K(3,3,1.);
	  J+K;
  	} 
	catch (BaseException& e) {
		cout << e.what() ;
	} 
	catch (...) {
		cout << "Something is wrong!";
	}

	return 0;
}

